var spreadNS = GC.Spread.Sheets;
var spread;
$(document).ready(function () {
    spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"));
	var sheet = spread.getActiveSheet();
    sheet.setColumnWidth(1, 300); 
    sheet.getRange(-1,1,-1,1).cellType(new FivePointedStarCellType());
    intSpread(sheet);
});


function intSpread(sheet) {
    var Style_can_click = new GC.Spread.Sheets.Style();
	Style_can_click.cellButtons = [];
	for(var i = 0; i < 2; i++){

		let registerName = 'registerName' + i;
		spread.commandManager().register(registerName,
			{
				canUndo: true,
				execute: function (context, options, isUndo) {
					var Commands = GC.Spread.Sheets.Commands;
					// 在此加cmd名称
					options.cmd = registerName;
					if (isUndo) {
						// isUndo 为true时，调用undoTransaction
						Commands.undoTransaction(context, options);
						return true;
					} else {
						// 开始事务
						Commands.startTransaction(context, options);
						alert(1);
						// 结束事务
						Commands.endTransaction(context, options);
						return true;
					}
				}
			}
		);
		var obj_temp = {
			position: GC.Spread.Sheets.ButtonPosition.left,
		};
		obj_temp.command = (sheet, row, col, option) => {
			spread.commandManager().execute({
				cmd: registerName,
				sheetName: sheet.name()
			});
		}
		let myStyle = {
			position: 0,
			visibility: 0,
			enabled: true,
			foreColor: '#0066ff',
			// useButtonStyle: true,
			hoverBackColor: '#0066ff',
			// buttonBackColor: "#0066ff"
		}
		obj_temp.caption = '测试按钮' + i;
		Object.assign(obj_temp, myStyle);
		
		Style_can_click.cellButtons.push(obj_temp);
		console.log(Style_can_click);
	}
    sheet.setStyle(0, 1, Style_can_click);
    
}


function FivePointedStarCellType() {
}
FivePointedStarCellType.prototype = new spreadNS.CellTypes.Base();
/* FivePointedStarCellType.prototype.paint = function (ctx, value, x, y, w, h, style, options) {
}; */
FivePointedStarCellType.prototype.getHitInfo = function (x, y, cellStyle, cellRect, context) {
	/* var xm = cellRect.x + cellRect.width / 2,
			ym = cellRect.y + cellRect.height / 2,
			size = 10; */
	var info = { x: x, y: y, row: context.row, col: context.col, cellRect: cellRect, sheetArea: context.sheetArea };
	/* if (xm - size <= x && x <= xm + size && ym - size <= y && y <= ym + size) {
		info.isReservedLocation = true;
	} */
    info.isReservedLocation = true;
	return info;
};
FivePointedStarCellType.prototype.processMouseUp = function (hitInfo) {
	//
};
FivePointedStarCellType.prototype.processMouseMove = function (hitInfo) {
	var sheet = hitInfo.sheet;
	var div = sheet.getParent().getHost();
	var canvasId = div.id + "vp_vp";
	var canvas = $("#"+canvasId)[0];
    canvas.style.cursor='pointer';
};

FivePointedStarCellType.prototype.createEditorElement = function (context) {
    var sheet = context.sheet;
    var row = context.row;
    var col = context.col;
    var div = document.createElement("div");
    div.setAttribute("gcUIElement", "gcEditingInput");
    div.style.backgroundColor= "white";
    div.style.overflow= "hidden";
    var input1 = document.createElement("input");
    var type = document.createAttribute('type');
    type.nodeValue="text";
    input1.setAttributeNode(type);
    input1.style.width = sheet.getColumnWidth(col) + "px";
    div.appendChild(input1);
    return div;
}

FivePointedStarCellType.prototype.getEditorValue = function (editorContext) {
    if (editorContext) {
        var input1 = editorContext.children[0];
        var value = input1.value;
        return value;
    }
}

FivePointedStarCellType.prototype.setEditorValue = function (editorContext, value) {
    if (value) {
        var input1 = editorContext.children[0];
        input1.value=value;
    }
}

